# Library guidelines

[TOC]

This guide is intended to help Jetpack library developers understand best
practices for designing and evolving their libraries.

It is an addendum to
s.android.com/api-guidelines,
which covers standard and practices for designing platform APIs, and it extends
beyond API guidelines to cover implementation details that are relevant to
clients of Jetpack libraries.

All platform API design guidelines also apply to Jetpack libraries, with any
additional guidelines or exceptions noted in this document. Jetpack libraries
also follow
[explicit API mode](https://kotlinlang.org/docs/reference/whatsnew14.html#explicit-api-mode-for-library-authors)
for Kotlin libraries.

<!--#include file="/company/teams/androidx/api_guidelines/modules.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/platform_compat.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/compat.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/deprecation.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/resources.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/dependencies.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/functionality.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/annotations.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/async.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/processors.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/kotlin.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/testing.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/checks.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/behavior_changes.md"-->

<!--#include file="/company/teams/androidx/api_guidelines/samples.md"-->
